function [R] = Core_fun (p1, p2, N3, f, SDD, res)


% p1
% p2
% Q;
% y2;
% R2;
% g;
% N3;


%     
%     N3=20;
%     f=6;
    
    pc = nchoosek([1:f],3); %possible_combinations
    
    
    
    for i=1:N3; % For the number of probable triangles
        %for j=1:3
            a1=p1(pc(i,1)); a2=p1(pc(i,2)); a3=p1(pc(i,3));
            b1=p2(pc(i,1)); b2=p2(pc(i,2)); b3=p2(pc(i,3));
            xx(1)=(b2-b1)/(a1-a2); 
            xx(2)=(b2-b3)/(a3-a2);
            xx(3)=(b3-b1)/(a1-a3);
            yy(1)=a1*xx(1)+b1;
            yy(2)=a2*xx(2)+b2;
            yy(3)=a3*xx(3)+b3;
 
        A(i)=(((xx(1)-xx(2)).^2 + (yy(1)-yy(2)).^2)).^0.5;
        B(i)=(((xx(1)-xx(3)).^2 + (yy(1)-yy(3)).^2)).^0.5;
        C(i)=(((xx(2)-xx(3)).^2 + (yy(2)-yy(3)).^2)).^0.5;
        
        XC(i)=( xx(1)* C(i) + xx(2)* B(i) + xx(3)* A(i) )/(A(i)+B(i)+C(i));
        YC(i)=( yy(1)* C(i) + yy(2)* B(i) + yy(3)* A(i) )/(A(i)+B(i)+C(i));        
        
        
        
        % -----  plotting --------------------
        %hold on, plot(xx(1),yy(1),xx(2),yy(2),xx(3),yy(3))
        pp1(i)=xx(1);
        pp2(i)=xx(2);
        qq1(i)=yy(1);
        qq2(i)=yy(2);
        hold on, plot(xx,yy,'.g','MarkerSize',20 )
%         hold on, plot(pp1,qq1,'.g','MarkerSize',20 );
%         hold on, plot(pp2,qq2, '.g','MarkerSize',20 );
        if i==N3;
            %xlswrite ('data.xlsx',pp1,1,B)
%            pp1
%            pp2
%            qq1
%            qq2
%            XC
%            YC
%            hold on, plot(pp1,qq1,pp2,qq2, '.g','MarkerSize',20 );
        end
        a1=[]; a2=[]; a3=[];
        b1=[]; b2=[]; b3=[];
        xx=[]; yy=[];
        %A=[]; B=[]; C=[];
    end
    
    % find AREA
    for kk=1:N3;
        S(kk)=(A(kk)+B(kk)+C(kk))/2;
        Area(kk)=( S(kk)*(S(kk)-A(kk)) * (S(kk)-B(kk)) * (S(kk)-C(kk)) ).^0.5;  % Heron's formula
        R(kk)= Area(kk)./S(kk); % new line by pejman (15-08-2013); larger R
    end

    n=find(Area==max(Area));
    n=find(R==max(R));% new line by pejman (15-08-2013); larger R

    R= Area(n)./S(n);  % final answer (RADIUS)
    
    
    
%%% plotting the circle
x=XC(n);
y=YC(n);
r=R;
ang=0:0.01:2*pi; 
xp=r*cos(ang);
yp=r*sin(ang);
hold on, plot(x+xp,y+yp, 'r' ,'LineWidth',2);
hold on, plot(x,y, '.r','MarkerSize',25 );
XR=x:0.001:x+r; YR=y*ones(size(XR));
hold on, plot (XR,YR,'r' ,'LineWidth',2); 
r_val=num2str(r*res*100/SDD, '%3.3f');
RValue=['R= ',r_val, ' (mm)'];
text(x,y+0.05,RValue,'FontSize',10, 'fontweight','b' )
    
    
end
               
               
           