function [X1F, Y1F, X2F, Y2F, X3F, Y3F, g, SDD] = StarShot_fun (dImg)
a=dImg;

% ---------------------------------------------------------------------
% clear all, close all, 
%%%% HandyFinder;
% disp 'Please open your image'
%      [dFileName, dPathName] = uigetfile('*.dcm','Open image'); 
%      filename = [dPathName dFileName];
%       [Dose1 header frames SDD pixres] = LoadEpid(filename);
%       a=Dose1;
% ---------------------------------------------------------------------



% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
%      Gaussian Filter
h=fspecial('gaussian',[10 10],2);
a=filter2(h,a);
% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-


aa=a;
[v,g]=size(aa);


% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
%      Nois Damper
for j=2:numel(a);
   if a(j)*0.01 > (a(j-1));
      a(j)=a(j-1);
   end
end
% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_


%figure, imagesc(a)
% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
%      Edge detection
aedg=edge(a,'canny', 0.999); %figure, imagesc(aedg);
% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-


% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
%      Star hand direction
[nn,mm]=find(aedg==1);
L = (max(nn)-0) -  (min(nn)+0);
W = (max(mm)-0) -  (min(mm)+0);
if L >= W;
    sw=1;
else
    sw=2;
end
% _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-


t=1;
if sw==1;
   for i=min(nn)+10 :max(nn)-10; %i=1:v;
       [I, K]=find ((a(i,:))==max(a(i,:))); I=I(1); K=K(1);
       PX=a(i,:);
       [Centre] = Peak_Fun (PX);
       P(t)=i;
       QQ(t)=K;     % with pixel accuracy
       Q(t)=Centre; % with subpixel accuracy
       t=t+1;
       I=[]; K=[]; PX=[]; Centre=[];
   end
end

t=1;
if sw==2;
   for i=min(mm)+20:max(mm)-20; %i=1:g;
       [I, K]=find ((a(:,i))==max(a(:,i))); I=I(1); K=K(1);
       PX=a(:,i);
       [Centre] = Peak_Fun (PX);
       Q(t)=i; % it was P before
       %QQ(t)=K;
       P(t)=Centre; % it was Q before
       t=t+1;
       I=[]; K=[]; PX=[]; Centre=[];
   end
end



%figure, plot(P)

%%figure, plot(QQ) % with pixel accuracy
% figure, plot(Q)  % with sub-pixel accuracy
% 
% %figure, plot(QQ,P)
% figure, plot(Q,P)


 % _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
%      poly fit 1 
 p=polyfit(Q,P,1);
 y2=polyval(p,Q);
 %figure, plot(Q,P,Q,y2)
%  a1=p(1);
%  b1=p(2);
 % _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
  
 
 
 % _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
%      R-square 
 Y=mean(P);
 SStot=sum ( (P-Y).^2);
 SSres=sum ((y2-P).^2);
 R2=1-(SSres/SStot); % R-square
 
 % _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-


%    figure for paper
% figure, imagesc(zeros(size(a))), hold on, plot (Q,P), hold off, Colormap('Gray')
% b=ones(size(a)); b(round(P),round(Q))=100; figure, image(b),Colormap('Gray'),
%figure, imagesc(a), hold on, plot (Q,P,Q,y2), hold off, Colormap('Gray')
 figure, imagesc(a), hold on, plot (Q,P,Q,y2), hold off

%hold on, imagesc(a), hold on, plot (Q,P,Q,y2)

% a0= 491.6816; 
% b0=  -2.5189e+005;
% 
% a45= 0.9961;
% b45= -127.8494;
% 
% a90=  -0.0018 ;
% b90= 382.9027;
% 
% a135= -1.0007;
% b135= 893.9104;

% A=ones(768,1024); 
% x=1:1024;
% y0=a0*x+b0;
% y45=a45*x+b45;
% y90=a90*x+b90;
% y135=a135*x+b135;
% figure, imagesc(A), hold on, plot(x,y1,x,y45,x,y90,x,y135)



%xx=(b2-b1)/(a1-a2)


